#include "turtle3d.h"
//#include <iostream.h>
class tcurve : public turtle3d
{
public:
   tcurve(const double x, const double y, const double z, const double a, const double t, const double s, const double p)
      :turtle3d(x,y,z,a,t),initx(x), inity(y), initz(z), initang(a), inittilt(t), initscale(s), param(p),
	   THRESHMIN(0.00001), THRESHMAX(1.), thresh(0.003){}
   virtual void draw(int level, double length=1)=0;
   virtual void ward(const int level, const double length=1);
   virtual void fdrawf(const int level, const double length){flip();draw(level,length);flip();}
   virtual void fwardf(const int level, const double length){flip();ward(level,length);flip();}
   void reset(){setpos(initx,inity,initz); setang(initang); settil(inittilt); setscale(initscale);}
   void setparam(const double val){param=val;}
   void paramup(){param+=.005; if (param>1.) param=1.; /*cerr<<param<<endl;*/}
   void paramdown(){param-=.005; if (param<0.) param=0.;/*cerr<<param<<endl;*/}
   void setthresh(const double val){thresh=val;}
   void threshup(){thresh*=1.5; if (thresh>THRESHMAX) thresh=THRESHMAX;}
   void threshdown(){thresh/=1.5; if (thresh<THRESHMIN) thresh=THRESHMIN;}
   virtual void atomdraw(int l, int d){ draw(l,d); }
   const double THRESHMIN;
   const double THRESHMAX;
protected:
   const double initx;
   const double inity;
   const double initz;
   const double initang;
   const double inittilt;
   const double initscale;
   double param;
   double thresh;
};

class koch : public tcurve
{
public:
koch(const double x=0, const double y=0, const double z=0, const double a=0, const double t=0, const double s=1, const double p=0):tcurve(x,y,z,a,t,s,p){}
void draw(int l, double d);
};

class koch2 : public tcurve
{
public:
koch2(const double x=0, const double y=0, const double z=0, const double a=0, const double t=0, const double s=1, const double p=0):tcurve(x,y,z,a,t,s,p){}
void draw(int level, double length);
};

class koch8 : public tcurve
{
public:
koch8(const double x=0, const double y=0, const double z=0, const double a=0, const double t=0, const double s=1, const double p=0):tcurve(x,y,z,a,t,s,p){}
void draw(int level, double length);
};

class tower : public tcurve
{
public:
tower(const double x=0, const double y=0, const double z=0, const double a=0,
const double t=0, const double s=0.5, const double p=1./3.):tcurve(x,y,z,a,t,s,p){}
void draw(int level, double length);
};

class terdragon : public tcurve
{
public:
terdragon(const double x=0, const double y=0, const double z=0, const double a=0, const double t=0, const double s=1, const double p=0):tcurve(x,y,z,a,t,s,p){}
void draw(int level, double length);
};

class sierpinski : public tcurve
{
public:
sierpinski(const double x=0, const double y=0, const double z=0, const double
a=0, const double t=0, const double s=1, const double p=1./3.):tcurve(x,y,z,a,t,s,p){}
void draw(int level, double length);
};

class peano : public tcurve
{
public:
peano(const double x=0, const double y=0, const double z=0, const double a=0, const double t=0, const double s=1, const double p=0):tcurve(x,y,z,a,t,s,p){}
void draw(int level, double length);
};

class hshapebottom : public tcurve
{
public:
hshapebottom(const double x=0, const double y=0, const double z=0, const double a=0, const double t=0, const double s=1, const double p=0):tcurve(x,y,z,a,t,s,p){}
void draw(int level, double length);
};

class dragon : public tcurve
{
public:
dragon(const double x=0, const double y=0, const double z=0, const double a=0,
const double t=0, const double s=1, const double p=1/sqrt(3.0)):tcurve(x,y,z,a,t,s,p){}
void draw(int level, double length);
};

class test1 : public tcurve
{
public:
test1(const double x=0, const double y=0, const double z=0, const double a=0,
const double t=0, const double s=1, const double p=1.):tcurve(x,y,z,a,t,s,p){}
void draw(int level, double length);
void atomdraw(int level, double length);
};

class test2 : public tcurve
{
public:
test2(const double x=0, const double y=0, const double z=0, const double a=0,
const double t=0, const double s=1, const double p=2./3.):tcurve(x,y,z,a,t,s,p){}
void draw(int level, double length);
void atomdraw(int level, double length);
};

class test3 : public tcurve
{
public:
test3(const double x=0, const double y=0, const double z=0, const double
a=0, const double t=0, const double s=1, const double p=1./3.):tcurve(x,y,z,a,t,s,p){}
void draw(int level, double length);
};

class test4 : public tcurve
{
public:
test4(const double x=0, const double y=0, const double z=0, const double a=0, const double t=0, const double s=1, const double p=0):tcurve(x,y,z,a,t,s,p){}
void draw(int level, double length);
void ward(const int level, const double length);
};

class test5 : public tcurve
{
public:
test5(const double x=0, const double y=0, const double z=0, const double a=0, const double t=0, const double s=1, const double p=0):tcurve(x,y,z,a,t,s,p){}
void draw(int level, double length);
};

class test6 : public tcurve
{
public:
test6(const double x=0, const double y=0, const double z=0, const double a=0, const double t=0, const double s=1, const double p=0):tcurve(x,y,z,a,t,s,p){}
void draw(int level, double length);
};
